//+------------------------------------------------------------------+
//|                                                       AKF_01.mq4 |
//|                                      Copyright  2007, komposter |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_minimum -1.0
#property indicator_maximum 1.0
#property indicator_color1 Red
#property indicator_color2 Orange
#property indicator_color3 Yellow
#property indicator_color4 Green
#property indicator_color5 Aqua
#property indicator_color6 Blue
#property indicator_color7 Magenta

extern int		BarsCount				= 1000;
extern bool		WriteToFile				= false;

int		CountedBar = 0, CurAKF = -1;
double	AKF1[], AKF2[], AKF3[], AKF4[], AKF5[], AKF6[], AKF7[], Mu[];
color		Colors[8] = { Red, Orange, Yellow, Green, Aqua, Blue, Magenta, Gray };
int init()
{
	IndicatorBuffers	( 8 );

	SetIndexBuffer		( 0, AKF1 );
	SetIndexStyle		( 0, DRAW_LINE );
	SetIndexLabel		( 0, "AKF1" );

	SetIndexBuffer		( 1, AKF2 );
	SetIndexStyle		( 1, DRAW_LINE, STYLE_DASH );
	SetIndexLabel		( 1, "AKF2" );

	SetIndexBuffer		( 2, AKF3 );
	SetIndexStyle		( 2, DRAW_LINE, STYLE_DASH );
	SetIndexLabel		( 2, "AKF3" );

	SetIndexBuffer		( 3, AKF4 );
	SetIndexStyle		( 3, DRAW_LINE, STYLE_DASH );
	SetIndexLabel		( 3, "AKF4" );

	SetIndexBuffer		( 4, AKF5 );
	SetIndexStyle		( 4, DRAW_LINE, STYLE_DASH );
	SetIndexLabel		( 4, "AKF5" );

	SetIndexBuffer		( 5, AKF6 );
	SetIndexStyle		( 5, DRAW_LINE, STYLE_DASH );
	SetIndexLabel		( 5, "AKF6" );

	SetIndexBuffer		( 6, AKF7 );
	SetIndexStyle		( 6, DRAW_LINE, STYLE_DASH );
	SetIndexLabel		( 6, "AKF7" );

	SetIndexBuffer		( 7, Mu );
	SetIndexStyle		( 7, DRAW_NONE, STYLE_DASH );

	BarsCount ++;
	if ( BarsCount < 0 || BarsCount >= Bars ) BarsCount = Bars-1;
	return(0);
}

int deinit()
{
	for ( int cur = 0; cur <= 6; cur ++ ) ObjectDelete( StringConcatenate( "AKF_01-Mu-", cur ) );
	return(0);
}

int start()
{
	if ( Time[0] <= CountedBar ) { return(0);}
	CountedBar = Time[0];

	if ( CurAKF >= 0 )
	{
		int a;
		for ( a = BarsCount; a >= 0; a -- ) AKF7[a+7] = AKF6[a+7];
		for ( a = BarsCount; a >= 0; a -- ) AKF6[a+6] = AKF5[a+6];
		for ( a = BarsCount; a >= 0; a -- ) AKF5[a+5] = AKF4[a+5];
		for ( a = BarsCount; a >= 0; a -- ) AKF4[a+4] = AKF3[a+4];
		for ( a = BarsCount; a >= 0; a -- ) AKF3[a+3] = AKF2[a+3];
		for ( a = BarsCount; a >= 0; a -- ) AKF2[a+2] = AKF1[a+2];

		AKF1[BarsCount+1] = EMPTY_VALUE;
		AKF2[BarsCount+2] = EMPTY_VALUE;
		AKF3[BarsCount+3] = EMPTY_VALUE;
		AKF4[BarsCount+4] = EMPTY_VALUE;
		AKF5[BarsCount+5] = EMPTY_VALUE;
		AKF6[BarsCount+6] = EMPTY_VALUE;
		AKF7[BarsCount+7] = EMPTY_VALUE;
	}

	CurAKF ++;
	if ( CurAKF > 6 ) CurAKF = 0;

	int correct; string line_name;
	for ( int cur = 0; cur <= 6; cur ++ )
	{
		line_name = StringConcatenate( "AKF_01-Mu-", cur );
		correct = CurAKF-cur;
		if ( correct < 0 ) correct += 7;
		if ( correct == 0 )
		{
			string new_line_name = StringConcatenate( "AKF_01-Mu-", TimeToStr( ObjectGet( line_name, OBJPROP_TIME2 ) ) );
			ObjectCreate	( new_line_name, OBJ_TREND, 0, ObjectGet( line_name, OBJPROP_TIME1 ), ObjectGet( line_name, OBJPROP_PRICE1 ), ObjectGet( line_name, OBJPROP_TIME2 ), ObjectGet( line_name, OBJPROP_PRICE2 ) );
			ObjectSet		( new_line_name, OBJPROP_COLOR, Colors[7] );
			ObjectSet		( new_line_name, OBJPROP_RAY, false );
			ObjectSet		( new_line_name, OBJPROP_STYLE, STYLE_DASHDOTDOT );
			ObjectSet		( new_line_name, OBJPROP_WIDTH, 1 );
		}
		else
		{
			ObjectSet( line_name, OBJPROP_COLOR, Colors[correct] );
//			ObjectSet( line_name, OBJPROP_STYLE, STYLE_DASH );
		}
	}

	//    
	double sumy = Close[1], sumx = 0.0, sumxy = 0.0, sumx2 = 0.0;
	for ( int i = 2; i <= BarsCount; i ++ )
	{
		sumy+=Close[i];
		sumxy+=Close[i]*i;
		sumx+=i;
		sumx2+=i*i;
	}
	double Norma = sumx2*(BarsCount+1)-sumx*sumx;
	if ( MathAbs( Norma ) < 0.00000001 )
	{
		Print("Norma = 0");
		return;
	}
   double B=(sumxy*(BarsCount+1)-sumx*sumy)/Norma;
   double A=(sumy-sumx*B)/(BarsCount+1);

	line_name = StringConcatenate( "AKF_01-Mu-", CurAKF );
	ObjectCreate	( line_name, OBJ_TREND, 0, Time[BarsCount], A+B*(BarsCount+1), Time[1], A );
	ObjectMove		( line_name, 0, Time[BarsCount], A+B*(BarsCount+1) );
	ObjectMove		( line_name, 1, Time[1], A );
	ObjectSet		( line_name, OBJPROP_COLOR, Colors[0] );
	ObjectSet		( line_name, OBJPROP_RAY, false );
	ObjectSet		( line_name, OBJPROP_STYLE, STYLE_SOLID );
	ObjectSet		( line_name, OBJPROP_WIDTH, 1 );

	for ( i = BarsCount; i > 0; i -- ) Mu[i] = ObjectGetValueByShift( line_name, i );


	//    
	double SKO = 0.0;
	for ( i = BarsCount; i > 0; i -- ) SKO += MathPow( Close[i] - Mu[i], 2 );
	SKO /= BarsCount;
	Comment( "SKO = ", DoubleToStr( SKO, 8 ) );

	//  
	for ( int m = BarsCount; m > 0; m -- )
	{
		double summ = 0.0;
		for ( i = BarsCount; i > 0; i -- )
		{
			if ( i+m > BarsCount ) continue;
			summ += ( Close[i] - Mu[i] ) * ( Close[i+m] - Mu[i+m] );
		}
		AKF1[m] = 1/SKO*summ;
	}

	// 5. 
	//   AKFm     ,    0 	
	for ( m = BarsCount; m > 0; m -- ) AKF1[m] /= AKF1[1];

	if ( WriteToFile )
	{
		WriteToFile = false;
		//  
		int handle = FileOpen( StringConcatenate( "AKF_", Symbol(), "_", Period(), "_normal.csv" ), FILE_CSV | FILE_WRITE );
		//  
		if ( handle > 0 )
		{
			FileWrite( handle, "Price", "AKF" );
			//     
			for ( m = BarsCount; m > 0; m -- )
			{
				//   
				FileWrite( handle, DoubleToStr( Close[m], Digits ), DoubleToStr( AKF1[m], Digits ) );
			}
			//  
			FileClose(handle);
		}
		//  
		else
		{
			Print( "OpenFile error #", GetLastError() );
		}

		handle = FileOpen( StringConcatenate( "AKF_", Symbol(), "_", Period(), "_reverse.csv" ), FILE_CSV | FILE_WRITE );
		//  
		if ( handle > 0 )
		{
			FileWrite( handle, "Price", "AKF" );
			//     
			for ( m = 1; m <= BarsCount; m ++ )
			{
				//   
				FileWrite( handle, DoubleToStr( Close[m], Digits ), DoubleToStr( AKF1[m], Digits ) );
			}
			//  
			FileClose(handle);
		}
		//  
		else
		{
			Print( "OpenFile error #", GetLastError() );
		}
	}

	return(0);
}

